Allow GNU Patch tests to run with non-bash shell.
Fix gnused url.
This commit is contained in:
parent
66798d7aaf
commit
58e6277d77
3 changed files with 71 additions and 3 deletions
67
pkgs/tools/text/gnupatch/bashishms.patch
Normal file
67
pkgs/tools/text/gnupatch/bashishms.patch
Normal file
|
@ -0,0 +1,67 @@
|
|||
http://lists.gnu.org/archive/html/bug-patch/2012-11/msg00001.html
|
||||
Tested on Illumos, where ksh is /bin/sh.
|
||||
|
||||
--- patch-2.7.1/tests/test-lib.sh
|
||||
+++ patch-2.7.1/tests/test-lib.sh
|
||||
@@ -118,7 +118,7 @@
|
||||
}
|
||||
|
||||
if test -z "`echo -n`"; then
|
||||
- if eval 'test -n "${BASH_LINENO[0]}" 2>/dev/null'; then
|
||||
+ if (eval 'test -n "${BASH_LINENO[0]}"') 2>/dev/null; then
|
||||
eval '
|
||||
_start_test() {
|
||||
echo -n "[${BASH_LINENO[2]}] $* -- "
|
||||
|
||||
--- patch-2.7.1/tests/crlf-handling
|
||||
+++ patch-2.7.1/tests/crlf-handling
|
||||
@@ -14,7 +14,7 @@
|
||||
use_tmpdir
|
||||
|
||||
lf2crlf() {
|
||||
- while read l; do echo -e "$l\r"; done
|
||||
+ while read l; do printf "%s\r\n" "$l"; done
|
||||
}
|
||||
|
||||
echo 1 > a
|
||||
|
||||
--- patch-2.7.1/tests/merge
|
||||
+++ patch-2.7.1/tests/merge
|
||||
@@ -32,18 +32,20 @@
|
||||
shift
|
||||
done > a.sed
|
||||
echo "$body" | sed -f a.sed > b
|
||||
- shift
|
||||
- while test $# -gt 0 ; do
|
||||
- echo "$1"
|
||||
+ if test $# -gt 0 ; then
|
||||
shift
|
||||
- done > b.sed
|
||||
+ while test $# -gt 0 ; do
|
||||
+ echo "$1"
|
||||
+ shift
|
||||
+ done
|
||||
+ fi > b.sed
|
||||
echo "$body" | sed -f b.sed > c
|
||||
rm -f a.sed b.sed
|
||||
output=`diff -u a b | patch $ARGS -f c`
|
||||
status=$?
|
||||
echo "$output" | sed -e '/^$/d' -e '/^patching file c$/d'
|
||||
cat c
|
||||
- test $status == 0 || echo "Status: $status"
|
||||
+ test $status = 0 || echo "Status: $status"
|
||||
}
|
||||
|
||||
x() {
|
||||
|
||||
--- patch-2.7.1/tests/read-only-files
|
||||
+++ patch-2.7.1/tests/read-only-files
|
||||
@@ -16,7 +16,7 @@
|
||||
|
||||
: > read-only
|
||||
chmod a-w read-only
|
||||
-if : 2> /dev/null > read-only; then
|
||||
+if (: > read-only) 2> /dev/null; then
|
||||
echo "Files with read-only permissions are writable" \
|
||||
"(probably running as superuser)" >&2
|
||||
exit 77
|
|
@ -14,8 +14,9 @@ stdenv.mkDerivation rec {
|
|||
configureFlags = [ "ac_cv_func_strnlen_working=yes" ];
|
||||
};
|
||||
|
||||
# Tests fail on FreeBSD due to a Bashism in the tests.
|
||||
doCheck = !stdenv.isFreeBSD;
|
||||
patches = [ ./bashishms.patch ];
|
||||
|
||||
doCheck = true;
|
||||
|
||||
meta = {
|
||||
description = "GNU Patch, a program to apply differences to files";
|
||||
|
|
|
@ -4,7 +4,7 @@ stdenv.mkDerivation {
|
|||
name = "gnused-4.2.2";
|
||||
|
||||
src = fetchurl {
|
||||
url = mirror://gnu/sed/sed-4.2.2.tar.gz;
|
||||
url = mirror://gnu/sed/sed-4.2.2.tar.bz2;
|
||||
sha256 = "f048d1838da284c8bc9753e4506b85a1e0cc1ea8999d36f6995bcb9460cddbd7";
|
||||
};
|
||||
|
||||
|
|
Loading…
Reference in a new issue